datablock AudioProfile(whipWhooshSound)
{
   filename    = "./woosh.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(whipCrackSound)
{
   filename    = "./crack.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("belt",   '<bitmap:add-ons/Weapon_belt/CI_belt> %1',    '%2 <bitmap:add-ons/Weapon_belt/CI_belt> %1',0.2,1);
datablock ProjectileData(beltProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::belt;
   radiusDamageType    = $DamageType::belt;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse     = 0;
   verticalImpulse  = 0;
   //explosion           = ;

   muzzleVelocity      = 30;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 100;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(beltItem)
{
category = "Weapon";  // Mission editor category
className = "Weapon"; // For inventory system

 // Basic Item Properties
shapeFile = "./belterskelter.dts";
rotate = false;
mass = 1;
density = 0.2;
elasticity = 0.2;
friction = 0.6;
emap = true;

//gui stuff
uiName = "Belt";
iconName = "./icon_belt";
doColorShift = true;
colorShiftColor = "1 1 1 1.000";

 // Dynamic properties defined by the scripts
image = beltImage;
canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(beltImage)
{
   // Basic Item properties
   shapeFile = "./belterskelter.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = beltItem;
   ammo = " ";
   projectile = beltProjectile;
   projectileType = Projectile;

casing = gunShellDebris;
shellExitDir        = "2.0 -1.3 1.0";
shellExitOffset     = "0 0 0";
shellExitVariance   = 15.0;
shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = beltItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
// Initial start up state
stateName[0]                     = "Activate";
stateTimeoutValue[0]             = 0.1;
stateTransitionOnTimeout[0]       = "Ready";

stateSound[0]= activateSound;

stateName[1]                     = "Ready";
stateTransitionOnTriggerDown[1]  = "PreFire";
stateAllowImageChange[1]         = true;

stateSequence[1]= "Ready";

stateName[2]                    = "PreFire";
stateTransitionOnTimeout[2]     = "Fire";
stateTimeoutValue[2]            = 0.1;
stateFire[2]                    = true;
stateAllowImageChange[2]        = false;
stateScript[2]                  = "onPreFire";
stateWaitForTimeout[2]= true;
stateSound[2]= whipWhooshSound;

stateName[3]                    = "Fire";
stateTransitionOnTimeout[3]     = "Smoke";
stateTimeoutValue[3]            = 0.075;
stateFire[3]                    = true;
stateAllowImageChange[3]        = false;
stateSequence[3]                = "fire";
stateScript[3]                  = "onFire";
stateWaitForTimeout[3]= true;
stateSound[3]= whipCrackSound;
   stateSequence[3]                = "Fire";

stateName[4] = "Smoke";
stateTimeoutValue[4]            = 0.5;
stateTransitionOnTimeout[4]     = "Ready";
};

function beltImage::onPreFire(%this,%obj,%slot)
{
%obj.playThread(2, shiftAway);
}

function beltImage::onFire(%this,%obj,%slot)
{
if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
return;
%obj.lastFireTime = getSimTime();

%obj.playThread(2, shiftTo);

%projectile = %this.projectile;
%spread = 0.000;
%shellcount = 1;

for(%shell=0; %shell<%shellcount; %shell++)
{
%vector = %obj.getMuzzleVector(%slot);
%objectVelocity = %obj.getVelocity();
%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
%velocity = VectorAdd(%vector1,%vector2);
%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
%velocity = MatrixMulVector(%mat, %velocity);

%p = new (%this.projectileType)()
{
dataBlock = %projectile;
initialVelocity = %velocity;
initialPosition = %obj.getMuzzlePoint(%slot);
sourceObject = %obj;
sourceSlot = %slot;
client = %obj.client;
};
MissionCleanup.add(%p);
}
return %p;
}
